/*
 * File:   YThread.h
 * Project: part of belofte - A Promising Chess Program
 * Author: yves
 *
 * Created on 26 juin 2017, 13:20
 */

#ifndef __YTHREAD_H__
#define __YTHREAD_H__

#include "belofte.h"

typedef pthread_t * YThread_t;
typedef void * YThreadFun_t;
typedef void * YThreadFunParam_t;
typedef void * YThreadParam_t;
typedef long YThreadRc_t;
typedef pthread_mutex_t YThreadMutex_t;

/* create new thread and start running it */
YThread_t YThread_Create(YThreadFun_t threadfun(YThreadFunParam_t),
        const YThreadParam_t param, YThreadRc_t * rcode);
/* cancel thread from inside thread */
void YThread_Terminate(YThread_t * tid);
/* cancel thread from outside thread */
YThreadRc_t YThread_Destroy(YThread_t tid, YThreadRc_t * rcode);
/* sleep for a number of milliseconds */
void YThread_Snooze(const long milliSeconds);

#define YThread_MutexLock pthread_mutex_lock
#define YThread_MutexUnLock pthread_mutex_unlock
#define YThread_MUTEXINIT PTHREAD_MUTEX_INITIALIZER

#endif /* __YTHREAD_H__ */
