/***********************************************************************************
 * File: alg1_eval.h
 * Project: part of belofte - A Promising Chess Program
 * Author: yves
 ***********************************************************************************/

#if !defined(__ALG1_EVAL_H__)
#define __ALG1_EVAL_H__

#include "belofte.h"

// --------------------------------------------------------------------

#define SCORE_DRAW 0
#define MOBILITY_DIVIDER 150.0
#define KING_DIVIDER 100.0

#define STATICPOS_FACTOR 1.5
#define STATICPOS_DIVIDER 100
#define DOUBLE_PAWN_MALUS -30

#define DYNAMICPOS_FACTOR 3
#define DYNAMICPOS_ROOKFACTOR 2
#define ENDGAME_MOBILITYFACTOR 2.5
#define DYNAMICPOS_DIVIDER 100

#define OPENING_LENGTH 16

// --------------------------------------------------------------------

#define FIELDVALUE_SIZE 128 // indexes based on ASCII piece letter

// --------------------------------------------------------------------

void e1_constructor(void);
t_score eval_pos(const t_boolean isWhite);
t_score eval_pos_failmaterial(const t_boolean isWhite,const t_score fMaterialCut);
int eval_countcaptures(void);
int eval_stale_pos(const t_boolean isWhite);
t_score eval_material(const t_boolean isWhite);
t_score eval_mobility(const t_boolean isWhite);
t_score eval_kingpos(const t_boolean isWhite);
t_score eval_staticpos(const t_boolean isWhite);
t_score eval_dynamicpos(const t_boolean isWhite);

#endif
