/***********************************************************************************
 * File: alg1_moves.h
 * Project: part of belofte - A Promising Chess Program
 * Author: yves
 ***********************************************************************************/

#if !defined(__ALG1_MOVES_H__)
#define __ALG1_MOVES_H__

#include "belofte.h"

// --------------------------------------------------------------------

void moves_initorder(const int iMoves);
int moves_qsinitorder(const int iMoves);
void moves_resort(void);
void moves_clearscores(void);

// --------------------------------------------------------------------

struct st_alg1_move {
  posid ucFrom; // from position
  posid ucTo; // to position
  t_promotion bFlag; // is a promotion move, piece
  t_boolean bNonSilent; // is a capture or check move
  t_score bValue; // evaluation of this move
  hashkey_t m_hash; // Zobrist derivate
};

// --------------------------------------------------------------------

typedef struct st_alg1_move t_alg1_move;

// --------------------------------------------------------------------

struct st_alg1_movelist {
  t_alg1_move m1_moves[MAX_MOVES_PER_POSITION];
  int m1_count;
};

// --------------------------------------------------------------------

typedef struct st_alg1_movelist t_alg1_moves;

// --------------------------------------------------------------------

#endif
