/***********************************************************************************
 * File: alg1_search.h
 * Project: part of belofte - A Promising Chess Program
 * Author: yves
 ***********************************************************************************/

#if !defined(__ALG1_SEARCH_H__)
#define __ALG1_SEARCH_H__

#include "belofte.h"

// --------------------------------------------------------------------

#define MAX_DEPTH_EXTENTION 20

#define ALLOWED_DEVIATION 0.02

// make sure scores converge to zero
#define DEPTH_PENALTY 0.000

// --------------------------------------------------------------------

#define CAPTURE_COLOUR_WHITE COLOUR_WHITE
#define CAPTURE_COLOUR_BLACK COLOUR_BLACK

// --------------------------------------------------------------------

#define TO_WHITE(x)  ((x))
#define TO_BLACK(x)  ((x) + (LOWERCASEBIT))

// --------------------------------------------------------------------

void alg1_constructor(void);
void alg1_iterativedeepening(const t_depth iDepth);
t_boolean alg1_isInCheck(const t_boolean lEvaluateForWhite);
void alg1_search_printablemove(char *szMove, const int iSelectedMove);

int count_movelist(const t_colour nColour);
int qsfill_movelist(const t_colour nColour);
int search_fill_movelist(const t_colour nColour);

t_boolean isUnderAttack(const posid iKingPos, const t_boolean bEvaluateForWhite);
unsigned int countUnderAttack(const posid iPiecePos, const t_boolean bEvaluateForWhite);
unsigned int isUnderMinorAttack(const posid iPiecePos, const t_piece cPiece, const t_boolean bEvaluateForWhite);

// --------------------------------------------------------------------

#endif

// eof