/*
 * File:   alg2_search.h
 * Project: part of belofte - A Promising Chess Program
 * Author: yves
 *
 * Created on 6 mars 2019, 00:16
 */

#if !defined(__ALG2_SEARCH_H__)
#define __ALG2_SEARCH_H__

#include "alg2_board.h"

class alg2_search {
public:
  alg2_search() : fScore(-SCORE_WON) {}
  alg2_search(const alg2_search& orig);

  virtual ~alg2_search() {
  };

  // main functions
  void initialboard();
  t_score search();
  bool isInCheck(bool bEvalForWhite);
  void fillSelectedMove(char *szMove);

private:
  char szSelectedMove[MAX_COORDMOVE_LENGTH];
  t_score fScore;
  alg2_board uiBoard;

  bool searchFromPos(alg2_board& pos);
};

#endif /* __ALG2_SEARCH_H__ */

// eof